





                          <<< D a t a k e n >>>


               A powerful file processor for the Atari ST
               ------------------------------------------

       ken v. To know, view, recognize, understand, descry (data)


















                              User's Manual

                Program and manual written by Tyson Gill
                     Copyright (C) 1990 GT Software




DISTRIBUTION

Dataken is a commercial copyrighted product distributed as 
shareware. It will be protected vigorously against unauthorized
usage. You are encouraged to copy and distribute the program
and manual freely as long as they are not altered in any way. 

If you keep Dataken, you are expected to send the author a
shareware "donation". The shareware system makes programs available
to you which you would never otherwise see because they may not
be commercially viable for any of a number of non-technical reasons.

Most people rationalize why they never pay for the shareware they
use. As a rule of thumb if you can't bring yourself to delete Dataken
within 2 weeks, you ought to pay for it since you probably feel it
MAY be of value. No shareware should have to 'pay for itself' before
you pay for it. 

The recommended dontaion for Dataken is $20. 
You can send your payment to:

     GT Software (Dataken)
     12114 Kirton Avenue
     Cleveland, Ohio 
     44135-3612

Registered owners can always obtain the most recent revision for 
free by sending in a disk along with a stamped and self-addressed 
disk mailer.

Please pass Dataken along to friends and bulletin boards. 


** DISCLAIMER **

GT Software provides Dataken as a general tool for a wide range of 
legitimate professional applications. We do not intend or approve of 
it's use in any unethical or illegal activities. We also are not in 
any way responsible or liable for any misuse of the program or any 
accidental or intentional damage incurred as a result of it's use.


WARRANTY (or lack thereof)

Dataken was originally developed as a personal tool for the author 
and works satisfactorily for his personal applications. Since it is 
such a powerful and unique program, GT Software has decided to make
Dataken available to the ST community. However, GT Software can offer
no warranty or guarantee of any kind for this product.


HOW TO REPORT BUGS OR MAKE SUGGESTIONS

Although we cannot guarantee immediate action, we do want very much 
to hear your comments, suggestions, and special needs.

Send to the address above or E-Mail to: GEnie @ T.GILL7

INTRODUCTION

Dataken can be thought of as a DATA FILE PROCESSOR. It feels
immediately familiar and comfortable since it works much like a word
processor. It has GEM scroll bars, block operations, search and
replace, and on screen editing. At that point the similarity ends
dramatically, however.

Dataken goes far beyond a word processor in that it will edit any 
kind of data file whether it is in ASCII, binary, or mixed 
format. It will allow you to edit any section of a file in any 
format. Display and edit one, two, or four byte scalars, unsigned 
scalars in decimal, hex, octal, or binary format, and single and 
double precision floating point numbers. 

Dataken can be used to analyze and rearrange the structure of 
unknown data base files, to do bit manipulations on graphic 
files, to analyze and display unknown data files, to inspect 
program output, to find occurrences of strings or numerics in 
binary code, to simplify encryption or decryption work, for file 
conversions, to port data between processors, or almost any other 
data file handling.

For character and string portions of the data, Dataken offers 
many display options. You can display only printable characters, 
define a character to represent non-printing characters, display 
non-printing characters as numerics, or interpret cr/lf control 
on screen.

To help discover unknown data file formats, Dataken will display 
data in ALL formats (character, one, two, and four byte scalars, 
floating, etc.) simultaneously so that the correct type for a 
particular section of data will be quickly apparent. Once you 
have identified the correct data type of each portion of the 
file, you can display and edit it in a seamless natural format.

In addition to it's ability to analyze, display, and edit data 
files, Dataken has special functions to allow you to process data 
files without having to write programming. It can create blocks 
of data to fabricate program input files. It can modify the data 
with a variety of algebraic and logical operations. It will even 
rearrange bits or bytes of data to allow you to port data to or 
from different processors.

Programmers will especially like the fact that Dataken will read 
or write a C structure description of a data file. It has special 
functions to reorganize sections of the file by structure 
elements. For data base work, it can rearrange and reformat the 
data base header, records, and fields. Dataken will also save an 
ASCII format version of the binary file.

Dataken can save many frustrating hours of work trying to inspect 
or modify data files by other means. 


SAMPLE APPLICATIONS

The first question people inevitably ask when they see a new product 
is "What can I do with it?". Unless we are talking about small utility
with a very specific function, that is a tough question. How would you
answer the question if someone asked it in reference to a word 
processor? You may be at a loss for a moment, and then say something 
trivial sounding about writing reports or correspondence. The skeptic 
would respond that he has little need for report writing and a pen and
paper or typewriter works fine for letters.

Well, you and I both know that word processors can be utilized in 
endless ways and that they save tremendous amounts of effort while 
enhancing our productivity greatly. Their utility is so taken for 
granted now that we are seldom asked to justify their existence.

Dataken is a new program concept, however, and people do usually ask 
"What can I do with it?". The truth is that there are endless
applications and if you have it available it can save tremendous
amounts of effort spent using "pencil and paper" alternatives.
Although the potential applications for Dataken are as varied as are
computer users, here are some samples.


    * Analyze and repair corrupted data files. 

    * Generate a data file for program testing.

    * Port a data file from another platform/processor.

    * Develop encryption/decryption schemes.

    * Analyze the format of a database file and reorganize it.

    * Extract text strings from program code or 
      a desktop publisher document.


Please let us know what uses you have found for Dataken so that we 
can communicate your ideas to other users.


OVERVIEW

Screen Layout

The Dataken workscreen consists of a menu bar, one of three display 
windows, and a status area. 


The Menu Bar

The menu bar has five drop down menus to select program operations. 
Some menu items have keyboard equivalents. If so, these are shown 
after the item name. Keyboard equivalents starting with a caret are 
control keys. The keyboard equivalents in the block menu are all 
alternate keys. Keyboard equivalents in parentheses such as (Delete) 
refer to that named key.

The 'File' menu contains options to load and save files, to save an
ascii version of the file, to load and save file structure 
definitions, to save the current configuration, and to exit the 
program.

The 'Display' menu contains options to select the current display 
window, to set the display preferences for character data, and to set 
the default data type for future operations.

The 'Goto' menu allows you to move to a particular byte in the data, 
a particular line in the display window, or move directly to the top 
or bottom of the display.

The 'Block' menu and the alternate set of keyboard equivalents allow 
you to perform block operations on the data. Start mark, end mark, 
cut, copy, paste, move, and delete block options are available. This 
menu also has an option to select the display preference for any 
marked block of data.

The 'Modify' menu allows you to erase or edit the current data 
element, to insert new elements into the file, to find and replace 
data, to generate new data, to perform algebraic and logical 
operations, or to do bit or byte manipulations.


Windows

Dataken can display the data file in three different windows. These 
are the 'Editor', the 'Comparison', and the 'Structure' windows. The 
Editor window displays the data just like a word processor. The 
Comparison window displays data in all formats simultaneously so that 
you can easily determine the correct data type. The Structure window 
displays the data as blocks just like a C language structure 
definition so that you can easily see the file structure and perform 
block operations.

You can change to any window by selecting the type from the 'Display' 
menu. The current window is displayed with a check mark in the menu.


LOADING A DATA FILE

Dataken will display and edit ANY kind of file, whether it be text or 
binary. To load a file, choose the 'Load File' item from the 'File'
menu. So just select a file of any type!


MOVING AROUND IN THE EDITOR DISPLAY

The Editor window works much like a word processor. Use the cursor 
keys or the vertical scroll bar to move through the document. The 
'Goto' menu has options for moving directly to the top or bottom of 
the file or to go to a particular byte or line.

Goto Menu

     Menu Item     Function
     ---------     --------
     Top           Set the cursor at the first element in the file
     End           Set the cursor at the last element in the file
     Byte          Select byte in file at which to place cursor
     Line          Select line in display at which to place cursor


Use the mouse to click on a particular location in the Editor window 
to place the cursor. As you move around you will notice that the 
cursor jumps to each data element and highlights the whole field. 
For instance, if you are displaying the data as single byte binary 
numerics, the cursor will show all eight characters of the data 
element field in reverse video. While moving through character data, 
the cursor will be a single character.

As you move the cursor around in the display, you will notice that 
the current line and byte display in the lower status window will 
update to indicate the current cursor location.


MARKING BLOCKS

To select blocks of data, move the cursor to the start and select 
'Start mark' from the 'Block' menu. You can also press alt-S or click 
the mouse on the current cursor location. Note that this is not 
actually a 'double click'. Instead it is just a single click on the 
current cursor location. 

When you start a block, the status window will display the location 
in bytes of the start of the block. 

To mark the end of block, move the cursor to the ending location and 
select 'End mark' from the 'Block' menu. You can also press alt-E or 
click a second time on the cursor. The status window will update to 
indicate the end mark location and the total number of marked bytes.

Once you have marked an area, you will be able to unmark, copy, cut, 
move, or delete the marked data. After cutting or copying to the 
cut/paste buffer, you can move the cursor to a different location and 
paste the data there. The status window always shows the size of data 
in the cut/paste buffer.

Note that Dataken does not prompt you to confirm copy or cut 
operations even if there is data in the cut/paste buffer already. 
When a cut or paste operation is executed, any data in the buffer is 
lost.

Block Menu

     Menu Item     Function
     ---------     --------
     Start mark    Mark current cursor location as a block start
     End mark      Mark current cursor location as a block end
     Mark all      Select the entire file for a block operation
     Unmark        Deselect the currently marked block
     Delete        Delete the currently marked block
     Copy          Copy the marked block to the cut/paste buffer
     Cut           Copy block then delete from file
     Paste         Insert the cut/paste buffer at cursor location
     Move          Cut marked block and paste at cursor
     data Type     Change the display mode of a marked block


CHANGING HOW THE DATA IS DISPLAYED

Dataken will display any section of data in any format you wish. To 
change the display format, use the 'data Type' item from the 'Block' 
menu. If you have not marked a block, the new data type will be 
applied to the whole screen. If you have selected a block of data 
only that block will be affected.

The 'Select Data Type' dialog box allows you to select from the 
following main data types:

     Type        Defined for purposes of this program as
     ----        ---------------------------------------
     Character   Ascii characters
     Short       One byte numeric
     Integer     Two byte numeric 
     Long        Four byte numeric
     Float       Four byte floating point
     Double      Eight byte floating point


The numeric data types can also be displayed as signed or unsigned 
scalars. Unsigned scalars can be displayed in decimal, hex, octal, or 
binary format. In binary format, each byte of two or four byte 
scalars is separated by a vertical bar '|' in order to identify the
bits easier.

Note that the current program interprets floating point according to 
IEEE format used by Megamax LaserC. 

Note also that any remaining (non-integral) characters will be set to 
character data types. For example, if you change 15 bytes to long 
data types, you will obtain three long scalars and three characters.


CHARACTER DISPLAY OPTIONS

For character data, there are a number of display options. To select 
a display option, use the 'Char format' item in the 'Display' menu. 
This option presents a dialog box which allows you to select one of 
the following modes:

     Character display mode           Effect on non-printing chars
     ----------------------           ----------------------------
     Show printing only               Ignore
     Convert non-printing to short    Display numerically
     Show strings only over __        Ignore
     Display non-printing as _        Display as some printing char 


The 'Show strings over __' mode causes Dataken to display only 
characters which are part of an uninterrupted character sequence 
terminated by a NUL ( a zero ). The user can enter a minimum length 
string to display. This is nice to avoid a lot of one or two 
character 'strings' which randomly occur in many documents.

Note that setting the character display mode will effect all 
character data in the document. It is not possible to display one
block of character data in one mode and another block in a second
mode. 

Also be aware that if you display non-printing characters as 
numerics, the data type of those characters is set to short. 
Subsequent character mode changes will not effect those shorts. If 
you wish to return to a different character display mode, you must 
first use the 'data Type' option to change all those shorts back to 
characters.


TERMINATING A LINE OF CHARACTERS

The 'Char format' dialog also has an option for selecting a value to 
interpret as a cr/lf on screen in order to start a new line. If you 
are viewing a text document, you may wish to interpret 10 (LF) or 13 
(CR) as a newline character in order to view the document in more 
natural format. If you are looking at strings, you may wish to set a 
0 (NULL) as the newline character so that each string will start on a 
new line.

By selecting 'Show printing only' and 'Interpret as newline 10' you 
can display most text files in natural format similar to a word 
processor.

MODIFYING THE DATA

The 'Modify' menu contains options for actually changing the contents 
of a file.

Erase

The erase option deletes the data element which is currently under 
the cursor. If a long numeric is currently selected, the erase option 
will delete four bytes of data from the file.

Space

The space option inserts a new data element at the current cursor 
location. The currently selected data element will be pushed ahead. 
The new element will be of the same type as the element under the 
cursor when the space was inserted.

Edit

This option allows you to edit the data element at the current cursor 
location. Data must be entered in whatever format is currently 
displayed, hex, binary, etc. Note that either the Return or Enter key 
on the Atari ST keyboard can be used as a keyboard equivalent for 
this option.

Find/Replace

Use this option to find and optionally replace character strings 
displayed on screen. 

1. Enter the target string in the 'Search for' field.

2. Enter the replacement string in the 'Replace with' field.

3. Select the 'Verify Replace' radio button to step through each 
occurrence and optionally replace or the 'Replace All' button to 
automatically replace all search strings with the replacement string.

4. Select 'Find/Replace'. 


Dataken will find the first occurrence of the target string after the 
current cursor position. If the 'Verify Replace' option was selected, 
Dataken will stop at the first occurrence and display the following 
prompt in the info line of the window...

     Match #1 found. R)eplace, Q)uit <next>

At this point, press 'R' to replace the current occurrence with the 
new string, 'Q' to cancel Find/Replace, or press any key to go on to 
the next occurrence without taking any action.


Generate

The generate option displays a dialog box with two editable fields, 
'Value' and 'Number'. The value is the contents of the data which 
will be generated and number is the number of data elements of the 
current default type to create. (The current default is shown on the 
right side of the Editor window info line and can be set using the
'Default type' item in the 'Display' menu.)

The new data will be put into the cut/paste buffer for insertion into 
the file.

For example, if you enter a value of 1 and a number of 100 and your 
default data type is long, Dataken will generate 400 bytes of data. 
It will consist of a sequence of three zeros followed by a one. This 
will effectively place 100 long ones into the cut/paste buffer.

After generating new data, it can be further customized using the 
'Operate' option.


Operate

This dialog box is a little complicated unless you are used to 
programming. It has two sections, an operation section and a 
conditional section. By selecting the operation to perform and the 
operational variable, you can modify data. For example, to add 10 to 
all data in the marked block, select the '+' option and enter 10 as 
the operating variable. 

If you enter an operating increment, Dataken will add this increment
to the operating variable after each operation. For example, entering 
a value of 0 and an increment of 2 with a bitwise AND operation '&' 
will effectively create a block of data which increases by increments 
of two ( 0,2,4,6,8... ).

It is also possible to add to this a conditional expression so that 
the specified operation will only take place on certain data. There 
are a huge number of potential operational combinations and we will 
leave it to your experimentation to try them all!


Bit order

This option displays a dialog box which allows you to specify any 
random bit order for the marked data. For example, if you enter 
'87654321', the marked bytes will be bit reversed. This is useful if 
porting data between 'little endian' and 'big endian' processors.

Any rearrangement is possible, but if anyone comes up with a genuine
use for another re-ordering arrangement, please let us know!


Byte swap

This option immediately swaps all byte pairs in the marked block. 
This is useful if porting data between high-low byte order and 
low-high byte order processors.

Long byte order

This option allows your to re-order up to four byte sections of the 
marked block into any new random order. Useful for four byte 
reversals or goodness knows what else.


SAVING FILES

Once you have modified a data file, it can be saved using the 'Save 
file' item in the 'File' menu. You will be prompted to enter a name 
to avoid mistakenly overwriting the original.

Alternatively, the 'Save ASCII' option allows you to save a text 
version of the file which is exactly the same as it is displayed in 
the Editor window. This file can be edited using a standard word 
processor or printed. It allows you to save a binary file in natural 
format.


SAVING THE CONFIGURATION

Selecting the 'Save CFG' item from the 'File' menu saves a 
configuration file called "DATAKEN.CFG". This file loads 
automatically if present when Dataken starts up and sets all of the 
display options and defaults to the stored settings. 


THE COMPARISON WINDOW

If you are working with an unknown data file, you may not know what 
data type to use to make sense of the data. In this case, the 
'Comparison' window is very helpful. Select the Comparison window 
using the 'Comparison' item in the 'Display' menu. A new window will 
appear which shows 16 bytes of data at a time.

On each row, the data is shown as a different data type. It is shown 
as simultaneously as

     16 one byte characters
     16 one byte unsigned shorts
     16 one byte signed shorts
     8 two byte unsigned integers
     8 two byte signed integers
     4 four byte unsigned longs
     4 four byte signed longs
     4 four byte floats
     2 eight byte double precision floats


By moving through the data file one byte at a time, the proper row 
should become obvious. Note that if you are in 4 byte long data, you 
would have to move one byte at a time until byte aligned before the 
data would make sense.

Once you have found the current data type, you can move 1, 2, 4, or 8 
bytes at a time through the section by clicking on the on screen 
buttons using the mouse. When the data stops making sense, note you 
location in the file and move one byte again to determine the type of 
the next block of data.

You can move directly within the Comparison window using the Goto 
menu and the horizontal scroll bar.


STRUCTURE FILES

Once you have identified and marked the various data types in a mixed 
file, you can save this structure in a file. The structure file can 
then be 'imposed' onto any similar data file to define the same data 
block types. The use of structures means that once you have analyzed 
and marked a file format you will not need to do it again if you 
reload that or another similar file.

This structure definition is the same format as a C language data 
structure definition. It can be included into a C program to read the 
file into a structure.

Use the 'Save C struct' option to write the file. You can enter any 
file name you like. If you use the same name as the data file and 
give it the extension 'STR', Dataken will look for this file when it 
loads the program next time and prompt you to see if you would like 
to use it.

In Dataken, the process of applying a structure file to the data is 
referred to as 'imposing' the structure on the data. Any structure 
file can be imposed to the current data using the 'Impose struct' 
item in the 'File' menu.


THE STRUCTURE WINDOW

Once you have identified and marked various blocks of data of 
different types, you can view the file structure by selecting the 
'Structure' item from the 'Display' menu. The Structure window allows 
you to see the entire file at a glance from a structural perspective.

The structure is the same as that stored in the structure file using 
the 'Save C struct' item from the 'File' menu. The structure is a C 
language type structure which specifies the size and type of each 
block of data. Display format options such as hex or binary are 
encoded as C language type comments after each structure element. 
Each block of the file are represented as one element (line) in the 
structure.

The nifty thing about this is that you can perform block operations 
on elements. Use the vertical scroll bar or the cursor keys to select 
the current element. The functions in the 'Block' menu can be used to 
copy, cut, paste, or move blocks by structure element. This is great 
for reorganizing data.

 
POSSIBLE ENHANCEMENTS

There are quite a few ways in which Dataken could be extended. Here 
are some of the things on the current wish list...

* Edit disk sectors

* Edit RAM

* Convert floating point formats such as DECVAX and IEEE

* Optimize screen handling, find/replace, and other routines for 
  greater efficiency and speed

* Independent fully functional windows with full screen sizing
  when a higher resolution monitor is used.

* An illustrated and more detailed manual

* Special menu functions for reorganizing data base files

* Character mode to show non-printing as nemonics such as FF or ACK

* Eight byte scalars

* Find/Replace data elements

* Expanded 'Operate' dialog with dual conditionals


Please let us know how which of these or other potential enhancements 
you feel would be most valuable.


Thanks for reviewing Dataken and for supporting shareware hope that 
it saves you a lot of time and frustration in whatever work you do or 
allows you to do things you would not otherwise have attempted.


Dataken Addendum - Database Additions
by John I. Spande, Ph.D.

A project I am involved in required a large amount of
analysis and manipulation of database files. Fortunately I have
know Tyson for many years and he was kind enough to give me
access to the source code of Dataken and allow me to make some
additions. Please be advised that these database additions were
done under severe time constraints and are only partially done.
While they were adequate (barely) in the current state for my
needs, the user interface is, at best, half-done and crude (in
some cases half-baked). They are included on a "as is" basis for
those who might find them useful. If a market sufficient to
justify the effort were to materialize, they could be brought up
to a professional, finished level.

The primary use of these functions, at least in the current
state, is to analyze and manipulate database files from programs
which have limited import/export capabilities and undocumented
file structure. The additions basically just add the capability
to use a repeating structure to Dataken's existing capabilities.

To enable this mode, go to the Database Menu and click on
"Database mode". The "Define header", "Record length", "Set
first field" and "Set next field" functions allow you to set the
size of these items using the "Block" function. They can also be
set by entering the values directly in to "Structure dialog".
The left side of the Structure dialog shows the structure of the
current file and the right side shows the structure which will
be output with the Database Save functions. "Save SDF" will save
the file in a fixed field length format while "Save delimited"
will save the file in a comma delimited ascii format with quotes
used to indicate string fields. The "Duplicate" button in the
Structure dialog will copy the left side structure to the right
side where it may be modified if desired. "Delete line" will
delete the line (field) selected by the buttons marked with left
arrows at the right. You may change the order and sizes of the
fields at will and even add new ones. Enter the number of the
field on the left side to the "#/N" parameter on the right side
to tell the program what data should go where (the names are for
your benefit only, the program ignores them). If you are adding
a new field to the output structure, enter N instead of a
number. Zeros or empty strings will be saved in any new fields.
Note that the size of the fields in the Structure dialog is in
units of "type", i.e., if a field is declared to be type int and
size is declared to be 2 then the program assumes 2 integers or
4 bytes. The supported types are char, int, and long.

The process of determining the structure is generally one
of trial and error until the display looks correct. The "First
record" and "Next record" functions under the "Goto" Menu are
very useful during this phase. Be sure to save your structure
frequently while doing this potentially tedious task.

Dataken is an immensely useful program. I regret that I was unable
to justify the time to do this program concept justice. I hope you 
find these database additions useful and your understanding and 
tolerance of their unfinished state is appreciated.